package com.ejgv.gvi;

import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;

import com.ejgv.gvi.adapters.ContactsListAdapter;
import com.ejgv.gvi.dmo.DMOContact;
import com.ejgv.gvi.ui.EmptyRecyclerView;
import com.ejgv.gvi.utils.ContactsLoader;
import com.ejgv.gvi.utils.URIHandler;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */

/**
 * A simple {@link Fragment} subclass.
 * create an instance of this fragment.
 */
public class ContactsFragment extends Fragment implements ContactsListAdapter.ContactsListAdapterListener, View.OnClickListener
{

    private static final String TAG = "ContactsFragment";

    private ArrayList<DMOContact> mContacts;

    // UI References
    private LinearLayoutManager mLayoutManager;
    private ContactsListAdapter mAdapter;
    private RecyclerView mRecyclerview;
    private LinearLayout mLlytContactsHeader;

    public ContactsFragment()
    {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);


    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState)
    {
        ActionBar actionBar = ((AppCompatActivity) getActivity()).getSupportActionBar();
        actionBar.setDisplayShowTitleEnabled(true);
        actionBar.setTitle(R.string.title_fragment_contacts);

        // Inflate the layout for this fragment
        View v = inflater.inflate(R.layout.fragment_contacts, container, false);

        mLlytContactsHeader = (LinearLayout)v.findViewById(R.id.contacts_header_llyt);
        mLlytContactsHeader.setOnClickListener(this);

        EmptyRecyclerView recyclerView = (EmptyRecyclerView) v.findViewById(R.id.contacts_recyclerView);
        setRecyclerView(recyclerView);

        mContacts = new ContactsLoader(getContext()).getContacts();

        ContactsListAdapter adapter = new ContactsListAdapter(getContext(), mContacts, this);
        mAdapter = adapter;
        mRecyclerview.setAdapter(mAdapter);

        return v;
    }

    /*
        PROTECTED METHODS
     */

    protected void setRecyclerView(RecyclerView recyclerView)
    {
        mRecyclerview = recyclerView;
        // use this setting to improve performance if you know that changes
        // in content do not change the layout size of the RecyclerView
        mRecyclerview.setHasFixedSize(true);
        // use a linear layout manager
        mLayoutManager = new LinearLayoutManager(getActivity());
        mRecyclerview.setLayoutManager(mLayoutManager);

        if (mAdapter != null)
            mRecyclerview.setAdapter(mAdapter);
    }

    /*
        IMPLEMENTS
        ContactsListAdapter.ContactsListAdapterListener
    */
    @Override
    public void onContactListAdapterItemClicked(View view, int position) {
        new URIHandler(getContext()).openMap(mContacts.get(position).getLat(),mContacts.get(position).getLng(), "Govierno vasco");
    }

    @Override
    public void onClick(View v) {
        new URIHandler(getContext()).openPhone(Constants.ZUZENEAN_LONG_NUMBER);
    }
}