package com.ejgv.gvi;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.text.Html;
import android.text.util.Linkify;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.ejgv.gvi.dao.DAOService;
import com.ejgv.gvi.dao.dto.DTOMessage;
import com.ejgv.gvi.dao.dto.DTOResponseGetMessages;
import com.ejgv.gvi.dialogs.SetCodeNameSingleChoiceDialogFragment;
import com.ejgv.gvi.dmo.DMOMessage;
import com.ejgv.gvi.restapipns.PNSHttpClient;
import com.ejgv.gvi.restapipns.dto.DTOPnsMsgPrivateResponseValues;
import com.ejgv.gvi.restapipns.dto.DTOResponseSimple;
import com.ejgv.gvi.restapipns.dto.DTOText;
import com.ejgv.gvi.restapipns.servicedataaccess.MezuPnsPCSService;
import com.ejgv.gvi.restapipns.servicesendingresponses.MezuPnsRSPService;
import com.ejgv.gvi.utils.Utils;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLDecoder;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link MessagePrivateFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link MessagePrivateFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class MessagePrivateFragment extends Fragment implements View.OnClickListener,
                                                                DAOService.OnGetPrivateMessageListener,
                                                                MezuPnsPCSService.OnMarkAsReadListener,
                                                                MezuPnsPCSService.OnDeleteListener,
                                                                MezuPnsRSPService.OnMsgInListener,
                                                                DAOService.OnGetMsgResponseValuesListener
{
    private static final String TAG = "MessagePrivateFragment";

    // the fragment initialization parameters
    private static final String ARG_MESSAGE = "MESSAGE";

    //
    private static final String TAG_DIALOGFRAGMENT_RESPONSES = "DIALOGFRAGMENT_RESPONSES";
    private static final int RESULT_CODE_DIALOGFRAGMENT_RESPONSES = 0;

    private DMOMessage mMessage;
    private AsyncTask mGetPrivateMessageAsyncTask;
    private AsyncTask mGetMsgResponseValuesAsyncTask;
    private AsyncTask mMarkAsReadAsyncTask;
    private AsyncTask mDeleteAsyncTask;
    private AsyncTask mMsgInAsyncTask;

    // UI References
    private RelativeLayout mProgressLayout;
    private TextView mTxtTsResponse;
    private TextView mTxtResponseText;
    private TextView mTxtPrivateText;
    private Button mBtnResponse;

    private OnFragmentInteractionListener mListener;
    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener
    {
        void onMarkAsRead(String trans_id, long tsRead);
        void onPnsMessageDelete(String trans_id);
    }
    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param message Parameter 1.
     * @return A new instance of fragment MessageDetailFragment.
     */
    public static MessagePrivateFragment newInstance(DMOMessage message)
    {
        MessagePrivateFragment fragment = new MessagePrivateFragment();
        Bundle args = new Bundle();
        args.putParcelable(ARG_MESSAGE, message);
        fragment.setArguments(args);
        return fragment;
    }

    public MessagePrivateFragment()
    {
        // Required empty public constructor
    }

    @Override
    public void onAttach(Context context)
    {
        super.onAttach(context);
        try {
            mListener = (OnFragmentInteractionListener) context;
        } catch (ClassCastException e) {
            throw new ClassCastException(context.toString()
                    + " must implement MessagePrivateFragment.OnFragmentInteractionListener");
        }
    }

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setHasOptionsMenu(true);

        if (getArguments() != null)
            mMessage = getArguments().getParcelable(ARG_MESSAGE);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState)
    {
        ActionBar actionBar = ((AppCompatActivity) getActivity()).getSupportActionBar();
        actionBar.setDisplayShowTitleEnabled(true);
        actionBar.setTitle(R.string.app_name);


        // Inflate the layout for this fragment
        View v = inflater.inflate(R.layout.fragment_message_detail, container, false);

        TextView txtTagAndTs = (TextView) v.findViewById(R.id.messageDetail_tagAndTs_txt);

        String strTag = null;
        if (mMessage.getPrivateMsg() != null && mMessage.getPrivateMsg().getTag() != null)
        {
            String strTagText = UtilsApp.getTextLocale(getContext(), mMessage.getPrivateMsg().getTag());
            if (strTagText != null)
            {
                strTag = Utils.boldPurged(Utils.color(Utils.getColorAPISafe(getContext(), R.color.gvi_grayDark), strTagText));
                actionBar.setTitle(strTagText);
            }
        }

        Calendar calendar = GregorianCalendar.getInstance();
        calendar.setTimeInMillis(mMessage.getTs());
        String strTsFormatted = null;
        try
        {
            strTsFormatted = Utils.getDateFormatted(calendar.getTime(), getString(R.string.dateformat_long, "<b><font color=\"#333\">", "</font></b>", "<b><font color=\"#333\">", "</font></b>"));
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }

        if (strTag != null && strTsFormatted != null)
            txtTagAndTs.setText(Html.fromHtml(getString(R.string.resume_from_tag_fragment_message_detail, strTag, strTsFormatted)));
        else if (strTsFormatted != null)
            txtTagAndTs.setText(Html.fromHtml(strTsFormatted));
        else
            txtTagAndTs.setVisibility(View.GONE);

        TextView txtPublicText = (TextView) v.findViewById(R.id.messageDetail_publicText_txt);
        txtPublicText.setText(mMessage.getPublicText());

        mTxtTsResponse = (TextView) v.findViewById(R.id.messageDetail_tsResponse_txt);
        mTxtResponseText = (TextView) v.findViewById(R.id.messageDetail_responseText_txt);
        mTxtPrivateText = (TextView) v.findViewById(R.id.messageDetail_privateText_txt);

        mBtnResponse = (Button) v.findViewById(R.id.messageDetail_response_btn);
        mBtnResponse.setOnClickListener(this);

        mProgressLayout = (RelativeLayout) v.findViewById(R.id.layoutProgressbar_main_lyt);
        
        return v;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState)
    {
        super.onActivityCreated(savedInstanceState);

        mProgressLayout.setVisibility(View.VISIBLE);

        DAOService daoService = new DAOService(getContext());
        mGetPrivateMessageAsyncTask = daoService.createGetPrivateMessageCall(this, mMessage.getIdTrans());
        mGetPrivateMessageAsyncTask.execute();
    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater)
    {
        inflater.inflate(R.menu.menu_message_private, menu);
        super.onCreateOptionsMenu(menu, inflater);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
        if (item.getItemId() == R.id.action_delete)
        {
            deleteMessageFromDatabase(new String[]{mMessage.getIdTrans()});
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        switch (requestCode)
        {
            case RESULT_CODE_DIALOGFRAGMENT_RESPONSES:

                if (resultCode == Activity.RESULT_OK)
                {
                    Bundle bundle = data.getExtras();
                    String strResponseCode = bundle.getString(SetCodeNameSingleChoiceDialogFragment.RESULT_PARAM_CODE);
                    String strResponseText = bundle.getString(SetCodeNameSingleChoiceDialogFragment.RESULT_PARAM_NAME);
                    confirmSendResponse(strResponseCode, strResponseText);
                }
                break;
            default:
                super.onActivityResult(requestCode, resultCode, data);
        }
    }

    @Override
    public void onDestroy()
    {
        if (mGetPrivateMessageAsyncTask != null)
            mGetPrivateMessageAsyncTask.cancel(true);

        if (mGetMsgResponseValuesAsyncTask != null)
            mGetMsgResponseValuesAsyncTask.cancel(true);
        
        if (mMarkAsReadAsyncTask != null)
            mMarkAsReadAsyncTask.cancel(true);

        if (mMsgInAsyncTask != null)
            mMsgInAsyncTask.cancel(true);

        super.onDestroy();
    }

    @Override
    public void onDetach()
    {
        super.onDetach();
        mListener = null;
        mGetPrivateMessageAsyncTask = null;
        mGetMsgResponseValuesAsyncTask = null;
        mMarkAsReadAsyncTask = null;
        mMsgInAsyncTask = null;
    }

    /*
        PRIVATE METHODS
     */

    private void initUIPrivateMessage()
    {
        updateUIMessageResponse();

        if(mMessage.getPrivateMsg() != null && mMessage.getPrivateMsg().getText() != null)
        {
            mTxtPrivateText.setVisibility(View.VISIBLE);
            String text = UtilsApp.getTextLocale(getContext(), mMessage.getPrivateMsg().getText());

            try {

                mTxtPrivateText.setText(normalizeURLs(URLDecoder.decode(text, "UTF-8")));

            } catch (Exception e) {

                UtilsLog.e(TAG, e.getStackTrace().toString());
            }
        }

        customLinkify();

        DAOService daoService = new DAOService(getContext());
        mGetMsgResponseValuesAsyncTask = daoService.createGetMsgResponseValuesCall(this, mMessage.getIdTrans());
        mGetMsgResponseValuesAsyncTask.execute();
    }

    private void updateUIMessageResponse()
    {
        long dateTsResponse = mMessage.getTsResponse();
        if (dateTsResponse > 0)
        {
            Calendar calendar = GregorianCalendar.getInstance();
            calendar.setTimeInMillis(dateTsResponse);

            String strTsResponded = null;
            try
            {
                strTsResponded = Utils.getDateFormatted(calendar.getTime(), getString(R.string.dateformat_long, "<b><font color=\"#333\">", "</font></b>", "<b><font color=\"#333\">", "</font></b>"));
            }
            catch (ParseException e)
            {
                e.printStackTrace();
            }
            String strTsResponsedFormatted = Utils.colorPurged(Utils.getColorAPISafe(getContext(), R.color.gvi_grayDark), strTsResponded);
            String strTsResponsedDate = getString(R.string.resume_responded_fragment_message_detail, strTsResponsedFormatted);
            mTxtTsResponse.setText(Html.fromHtml(strTsResponsedDate));
            mTxtTsResponse.setVisibility(View.VISIBLE);

            mTxtResponseText.setText(UtilsApp.getTextLocale(getContext(), mMessage.getResponseText()));
            mTxtResponseText.setVisibility(View.VISIBLE);
        }
        else
        {
            mTxtTsResponse.setVisibility(View.GONE);
            mTxtResponseText.setVisibility(View.GONE);
        }
    }

    private void initUIMsgResponseValues(DTOMessage[] messages)
    {
        if (messages.length > 0 && messages[0] != null && messages[0].getPrivateMsg() != null && messages[0].getPrivateMsg().getResponse() != null)
        {
            mMessage.getPrivateMsg().setResponse(messages[0].getPrivateMsg().getResponse());

            if(mMessage.getPrivateMsg().getResponse() != null)
                mBtnResponse.setVisibility(View.VISIBLE);
        }
    }

    private void markMessageAsRead()
    {
        mMessage.setTsRead((new Date()).getTime());

        DAOService daoService = new DAOService(getActivity());
        daoService.createMarkAsReadCall(mMessage.getIdTrans()).start();

        AccessData accessData = new AccessData(getContext());
        MezuPnsPCSService mezuPnsPCSService = new MezuPnsPCSService(getContext());
        mMarkAsReadAsyncTask = mezuPnsPCSService.createMarkAsReadCall(this, accessData.getUuidApp(), accessData.getUuidDevice(), mMessage.getIdTrans());
        mMarkAsReadAsyncTask.execute();

        mListener.onMarkAsRead(mMessage.getIdTrans(), mMessage.getTsRead());
    }

    private void showResponsesDialogFragment()
    {
        DTOPnsMsgPrivateResponseValues[] values = mMessage.getPrivateMsg().getResponse().getValues();
        String[] astrCodes = new String[values.length];
        String[] astrNames = new String[values.length];
        for (int i = 0, len = values.length; i < len; i++) {
            astrCodes[i] = values[i].getCode();
            DTOText text = new DTOText();
            text.setEu(values[i].getEu());
            text.setEs(values[i].getEs());
            astrNames[i] = UtilsApp.getTextLocale(getContext(), text);
        }

        int responsedPosition = Arrays.asList(astrCodes).indexOf(mMessage.getResponseCode());
        SetCodeNameSingleChoiceDialogFragment setCodeNameSingleChoiceDialogFragment;
        if (responsedPosition < 0)
        {
            setCodeNameSingleChoiceDialogFragment = SetCodeNameSingleChoiceDialogFragment.newInstance(
                                                            R.layout.layout_dialog_singlechoice,
                                                            getString(R.string.message_response_select_answer),
                                                            astrCodes,
                                                            astrNames
                                                    );
        }
        else
        {
            setCodeNameSingleChoiceDialogFragment = SetCodeNameSingleChoiceDialogFragment.newInstance(
                                                        R.layout.layout_dialog_singlechoice,
                                                        getString(R.string.message_response_select_answer),
                                                        astrCodes,
                                                        astrNames,
                                                        responsedPosition
                                                    );
        }
        setCodeNameSingleChoiceDialogFragment.setTargetFragment(this, RESULT_CODE_DIALOGFRAGMENT_RESPONSES);
        setCodeNameSingleChoiceDialogFragment.show(getFragmentManager(), TAG_DIALOGFRAGMENT_RESPONSES);
    }

    private void confirmSendResponse(final String strResponseCode, String responseText)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setTitle(R.string.confirm_send_response)
                .setMessage(responseText)
                .setPositiveButton(R.string.action_send, new DialogInterface.OnClickListener()
                {
                    @Override
                    public void onClick(DialogInterface dialog, int which)
                    {
                        insertResponse(strResponseCode);
                    }
                })
                .setNegativeButton(R.string.action_no, null);
        builder.create().show();
    }

    private void insertResponse(final String strResponseCode)
    {
        if (Utils.isConnected(getContext()))
        {
            Calendar calendar = GregorianCalendar.getInstance();
            mMessage.setTsResponse(calendar.getTimeInMillis());
            mMessage.setResponseCode(strResponseCode);
            AccessData accessData = new AccessData(getContext());
            MezuPnsRSPService mezuPnsRSPService = new MezuPnsRSPService(getContext());
            mMsgInAsyncTask = mezuPnsRSPService.createMsgInCall(this, mMessage.getPrivateMsg().getResponse().getAlias(), mMessage.getResponseCode(), accessData.getUuidApp(), accessData.getUuidDevice(), mMessage.getIdTrans(), mMessage.getTsResponse());
            mMsgInAsyncTask.execute();
        }
        else
        {
            Snackbar mySnackbar = Snackbar.make(getView().findViewById(R.id.messageDetail_coordinatorLayout),
                    getString(R.string.error_connection_no_connected), Snackbar.LENGTH_LONG);
            mySnackbar.setAction(
                    R.string.action_retry,
                    new View.OnClickListener()
                    {
                        @Override
                        public void onClick(View v)
                        {
                            insertResponse(strResponseCode);
                        }
                    }
            );
            mySnackbar.show();
        }
    }

    private void deleteMessageFromDatabase(final String[] trans_ids)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setTitle(R.string.action_delete_message)
                .setMessage(R.string.confirm_delete_long)
                .setPositiveButton(R.string.action_yes, new DialogInterface.OnClickListener()
                {
                    @Override
                    public void onClick(DialogInterface dialog, int which)
                    {
                        DAOService daoService = new DAOService(getActivity());
                        daoService.createDeleteMessagesCall(trans_ids).start();
                        AccessData accessData = new AccessData(getContext());
                        MezuPnsPCSService mezuPnsPCSService = new MezuPnsPCSService(getContext());
                        mDeleteAsyncTask = mezuPnsPCSService.createDeleteCall(MessagePrivateFragment.this, accessData.getUuidApp(), accessData.getUuidDevice(), trans_ids);
                        mDeleteAsyncTask.execute();
                        mListener.onPnsMessageDelete(trans_ids[0]);
                    }
                })
                .setNegativeButton(R.string.action_no, null);
        builder.create().show();
    }

    private void showResponseError(String code, DTOText description)
    {
        UtilsApp.showAlertDialogBasic(
                getActivity(),
                getActivity().getString(R.string.title_error_with_code, code),
                description
        );
    }

    protected String normalizeURLs(String html)
    {

        String[] pieces = html.split(" ");
        ArrayList<String> textParts = new ArrayList<>();
        String resultString = "";

        for(String piece : pieces) {

            String[] elementsSeparatedByLineEnding = piece.split("\n");

            for(String piece2 : elementsSeparatedByLineEnding) {

                try {
                    URL isURL = new URL(piece2);
                    String protocol = isURL.getProtocol();
                    String host = isURL.getHost();
                    String query = isURL.getQuery();
                    String path = isURL.getPath();
                    String questionMark = "?";

                    if (path.equals("")) {
                        path = "/";
                    }

                    if (query == null) {
                        query = "";
                        questionMark = "";
                    }

                    String url = protocol + "://" + host + path + questionMark + query;
                    textParts.add(url);
                } catch (MalformedURLException exception) {
                    textParts.add(piece2);
                }
            }
        }



        for (String s : textParts)
        {
            resultString += s + " ";
        }

        return resultString;
    }

    private void customLinkify() {

        Linkify.addLinks(mTxtPrivateText, Linkify.EMAIL_ADDRESSES);
        Linkify.addLinks(mTxtPrivateText, Linkify.PHONE_NUMBERS);
        Linkify.addLinks(mTxtPrivateText, Linkify.WEB_URLS);

        String regex = "[a-z]+:\\/\\/[^ \\n]*";

        Pattern pattern = Pattern.compile(regex);

        Linkify.addLinks(mTxtPrivateText, pattern, null, null, new Linkify.TransformFilter()
        {
            @Override
            public String transformUrl(Matcher match, String url)
            {
                String[] urlPieces = url.split("://");

                if (urlPieces.length==1) {
                    String[] wwwPieces = url.split("www.");
                    if (wwwPieces.length==1) {
                        return "http://www."+url;
                    }
                    return "http://"+url;
                }

                return url;
            }
        });

        mTxtPrivateText.setLinksClickable(true);
    }


    /*
        IMPLEMENTS
        View.OnClickListener
     */

    @Override
    public void onClick(View v)
    {
        if (v.getId() == R.id.messageDetail_response_btn)
            showResponsesDialogFragment();
    }

    /*
        IMPLEMENTS
        DAOService.OnGetPrivateMessageListener
     */

    @Override
    public void onPostGetPrivateMessageAsyncTask(DTOResponseGetMessages response)
    {
        if (getContext() == null)
            return;

        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK) && response.getMessages().length > 0)
        {
            DTOMessage message = response.getMessages()[0];

            if (message != null)
            {
                mMessage.setTsResponse(message.getTsResponse());
                mMessage.setResponseCode(message.getResponseCode());
                mMessage.setResponseText(message.getResponseText());
                mMessage.setPrivateMsg(message.getPrivateMsg());
                initUIPrivateMessage();

                if (message.getTsRead() == 0)
                    markMessageAsRead();
            }
        }
        else
            showResponseError(response.getCode(), response.getDescription());

        if (mProgressLayout != null)
            mProgressLayout.setVisibility(View.GONE);
    }

    /*
        IMPLEMENTS
        DAOService.OnGetMsgResponseValuesListener
     */

    @Override
    public void onPostGetMsgResponseValuesAsyncTask(DTOResponseGetMessages response)
    {
        if (getContext() == null)
            return;

        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK))
        {
            if (response.getMessages() != null && response.getMessages().length > 0)
                initUIMsgResponseValues(response.getMessages());
        }
        else
            showResponseError(response.getCode(), response.getDescription());
    }

    /*
        IMPLEMENTS
        MezuPnsPCSService.OnMarkAsReadListener
     */
    @Override
    public void onPostMarkAsReadAsyncTask(DTOResponseSimple response)
    {
        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK) && getActivity() != null)
        {
            DAOService daoService = new DAOService(getActivity());
            daoService.createDeleteMsgPendingOperationsCall(Constants.PNS_MESSAGE_OPERATION_MARK_AS_READ, new String[]{mMessage.getIdTrans()}).start();
        }
    }

    /*
        IMPLEMENTS
        MezuPnsPCSService.OnDeleteListener
     */

    @Override
    public void onPostDeleteAsyncTask(DTOResponseSimple response, String[] trans_ids)
    {
        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK)&& getActivity() != null)
        {
            DAOService daoService = new DAOService(getActivity());
            daoService.createDeleteMsgPendingOperationsCall(Constants.PNS_MESSAGE_OPERATION_DELETE, trans_ids).start();
        }
    }

    /*
        IMPLEMENTS
        MezuPnsRSPService.OnMsgInListener
     */

    @Override
    public void onPostMsgInAsyncTask(DTOResponseSimple response)
    {
        if (getActivity() == null)
            return;

        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK))
        {
            DAOService daoService = new DAOService(getActivity());
            daoService.createAddMessageResponsedCall(mMessage.getIdTrans(), mMessage.getResponseCode(), mMessage.getTsResponse()).start();

            if (getContext() == null)
                return;

            DTOPnsMsgPrivateResponseValues[] values = mMessage.getPrivateMsg().getResponse().getValues();
            for (int i=0, len=values.length; i < len; i++)
            {
                if (values[i].getCode().equals(mMessage.getResponseCode()))
                {
                    DTOText text = new DTOText();
                    text.setEu(values[i].getEu());
                    text.setEs(values[i].getEs());
                    mMessage.setResponseText(text);
                    updateUIMessageResponse();
                    break;
                }
            }
            Toast.makeText(getActivity(), R.string.action_response_ok_sent, Toast.LENGTH_SHORT).show();
        }
        else
        {
            mMessage.setTsResponse(0);
            mMessage.setResponseCode(null);
            showResponseError(response.getCode(), response.getDescription());
        }
    }
}