package com.ejgv.gvi;

import android.support.v4.app.ListFragment;
import android.os.Bundle;
import android.support.v4.widget.SwipeRefreshLayout;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public abstract class PullToRefreshListFragment extends ListFragment implements SwipeRefreshLayout.OnRefreshListener
{
	private SwipeRefreshLayout mPullToRefreshLayout;

	@Override
	public void onViewCreated(View view, Bundle savedInstanceState)
	{
		super.onViewCreated(view, savedInstanceState);
		mPullToRefreshLayout = (SwipeRefreshLayout) view.findViewById(R.id.news_swipeRefreshLayout);
	}
	
	protected SwipeRefreshLayout getPullToRefreshLayout()
	{
		return mPullToRefreshLayout;
	}
	
	protected void setPullToRefreshLayout(SwipeRefreshLayout pullToRefreshLayout)
	{
		this.mPullToRefreshLayout = pullToRefreshLayout;
	}
	
	protected void hideProgressBar()
	{
		View v_progressbar = getView().findViewById(R.id.layout_progressbar_on_list);
		if (v_progressbar != null)
			v_progressbar.setVisibility(View.GONE);
	}
	
	protected void showProgressBar()
	{
		View v_progressbar = getView().findViewById(R.id.layout_progressbar_on_list);
		if (v_progressbar != null)
			v_progressbar.setVisibility(View.VISIBLE);
	}
	
	protected void removeProgressBar()
	{
		View v_progressbar = getView().findViewById(R.id.layout_progressbar_on_list);
    	if (v_progressbar != null)
			((ViewGroup) v_progressbar.getParent()).removeView(v_progressbar);
	}
	
	protected void hideEmptyView()
	{
		getView().findViewById(R.id.layout_empty_list_txt).setVisibility(View.GONE);
	}
	
	protected void setEmptyView()
	{
		TextView txt_empty = (TextView) getView().findViewById(R.id.layout_empty_list_txt);
		txt_empty.setText( R.string.empty_list );
		txt_empty.setVisibility(View.VISIBLE);
	}
	
	protected void setEmptyView(int res_id)
	{
		TextView txt_empty = (TextView) getView().findViewById(R.id.layout_empty_list_txt);
		txt_empty.setText(res_id);
		txt_empty.setVisibility(View.VISIBLE);
	}
	
	protected void setEmptyView(String text)
	{
		TextView txt_empty = (TextView) getView().findViewById(R.id.layout_empty_list_txt);
		txt_empty.setText(text);
		txt_empty.setVisibility(View.VISIBLE);
	}
	
}