package com.ejgv.gvi;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Html;
import android.text.format.DateUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.WebView;
import android.widget.TextView;

import com.ejgv.gvi.rss.RSSFeedItem;
import com.ejgv.gvi.utils.Utils;

import java.text.SimpleDateFormat;

public class RSSFeedDetailFragment extends Fragment
{
	private final static String IN_PARAM_RSS_ITEM = "RSSFeedItem";
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
	}
	
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
    	RSSFeedItem item = getArguments().getParcelable(IN_PARAM_RSS_ITEM);
        // Inflate the layout for this fragment
    	View v = inflater.inflate(R.layout.fragment_gvi_rss_feed_detail, container, false);
    	
    	TextView txt_title = (TextView) v.findViewById(R.id.rssfeeddetail_title_txt);
    	txt_title.setText(item.getTitle());
    	
    	TextView txt_date = (TextView) v.findViewById(R.id.rssfeeddetail_date_txt);

    	txt_date.setText(DateUtils.getRelativeTimeSpanString(getActivity(), item.getPubDate().getTime().getTime(), false));
    	
    	WebView wv_description = (WebView) v.findViewById(R.id.rssfeeddetail_description_txt);
    	wv_description.loadDataWithBaseURL( null, item.getDescription(), "text/html", "utf-8", null );
    	
    	TextView txt_author = (TextView) v.findViewById(R.id.rssfeeddetail_author_txt);
    	if (item.getAuthor() != null)
    		txt_author.setText( Html.fromHtml("<b>"+getString(R.string.author) +":</b> "+ item.getAuthor()));
    	
    	return v;
    }
}