package com.ejgv.gvi;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.Snackbar;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.content.LocalBroadcastManager;
import android.telephony.SmsMessage;
import android.telephony.TelephonyManager;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.ejgv.gvi.restapipns.PNSHttpClient;
import com.ejgv.gvi.restapipns.dto.DTOResponseSimple;
import com.ejgv.gvi.restapipns.serviceappregister.MezuPnsPRSService;
import com.ejgv.gvi.ui.TypefaceEditText;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;

import java.util.UUID;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link RegisterStepTwoFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link RegisterStepTwoFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class RegisterStepTwoFragment extends Fragment
                                        implements View.OnClickListener,
                                                    MezuPnsPRSService.OnRegisterListener,
                                                    ActivityCompat.OnRequestPermissionsResultCallback
{
    private static final String TAG = "RegisterStepTwoFrg";

    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PHONE_NUMBER = "PHONE_NUMBER";
    private String mArgPhoneNumber;

    // CUSTOM VARIABLES
    private String mGcmToken;
    private String mUuidDevice;
    private AsyncTask mAsyncTask;
    private BroadcastReceiver mRegistrationBroadcastReceiver;
    private BroadcastReceiver mSmsReceiver;

    /**
     * Id to identify a camera permission request.
     */
    private static final int REQUEST_READ_PHONE_STATE = 0;

    // UI References
    private TypefaceEditText mEtxtSmsCode;
    private RelativeLayout mRlyProgressBar;
    private View mLayout;

    // CUSTOM INTERFACES
    private OnFragmentInteractionListener mListener;
    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener
    {
        void onRegisterStepTwoSuccess();
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @return A new instance of fragment RegisterStepTwoFragment.
     */
    public static RegisterStepTwoFragment newInstance(String param1)
    {
        RegisterStepTwoFragment fragment = new RegisterStepTwoFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PHONE_NUMBER, param1);
        fragment.setArguments(args);
        return fragment;
    }

    public RegisterStepTwoFragment()
    {
        // Required empty public constructor
    }

    @Override
    public void onAttach(Context context)
    {
        super.onAttach(context);
        try {
            mListener = (OnFragmentInteractionListener) context;
        } catch (ClassCastException e) {
            throw new ClassCastException(context.toString()
                    + " must implement RegisterStepTwoFragment.OnFragmentInteractionListener");
        }
    }

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        if (getArguments() != null) {
            mArgPhoneNumber = getArguments().getString(ARG_PHONE_NUMBER);
        }

        mRegistrationBroadcastReceiver = createRegistrationBroadcastReceiver();

        /*mSmsReceiver = createSmsBroadcastReceiver();
        registerSmsService(mSmsReceiver);*/

        if (checkPlayServices())
        {
            // Start IntentService to register this application with GCM.
            Intent intent = new Intent(getContext(), GCMRegistrationIntentService.class);
            getActivity().startService(intent);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState)
    {
        // Inflate the layout for this fragment
        View v =  inflater.inflate(R.layout.fragment_register_step_two, container, false);
        mLayout = v;

        TextView txtDescription = (TextView) v.findViewById(R.id.registerStepTwo_description_txt);
        txtDescription.setText(String.format(getString(R.string.description_fragment_register_step_two), mArgPhoneNumber));
        mEtxtSmsCode = (TypefaceEditText) v.findViewById(R.id.registerStepTwo_smsCode_etxt);

        mRlyProgressBar = (RelativeLayout) v.findViewById(R.id.layoutProgressbar_main_lyt);

        Button btnValidateSmsCode = (Button) v.findViewById(R.id.registerStepTwo_validateSmsCode_btn);
        btnValidateSmsCode.setOnClickListener(this);

        return v;
    }

    @Override
    public void onResume()
    {
        super.onResume();
        LocalBroadcastManager.getInstance(getActivity()).registerReceiver(mRegistrationBroadcastReceiver,
                new IntentFilter(Constants.GCM_REGISTRATION_COMPLETE));
    }

    @Override
    public void onPause()
    {
        LocalBroadcastManager.getInstance(getActivity()).unregisterReceiver(RegisterStepTwoFragment.this.mRegistrationBroadcastReceiver);

        super.onPause();
    }

    @Override
    public void onDestroy()
    {
        if (mSmsReceiver != null)
            getContext().unregisterReceiver(mSmsReceiver);

        if (mAsyncTask != null)
        {
            mAsyncTask.cancel(true);
            mAsyncTask = null;
        }

        super.onDestroy();
    }

    @Override
    public void onDetach()
    {
        mListener = null;
        super.onDetach();
    }

    @Override
    public void onClick(View v)
    {
        if (v.getId() == R.id.registerStepTwo_validateSmsCode_btn && mListener != null)
        {

            // Check if the Camera permission is already available.
            if (ActivityCompat.checkSelfPermission(getContext(), "android.permission.READ_PHONE_STATE")
                    != PackageManager.PERMISSION_GRANTED) {
                // Read phone state permission has not been granted.

                requestReadPhoneStatePermission();

            } else {

                String strSmsCode = mEtxtSmsCode.getText().toString().trim();
                if (isValidSmsCode(strSmsCode))
                {
                    mUuidDevice = getGeneratedDeviceUuid();
                    startAppRegistration(strSmsCode);
                }
            }
        }
    }

    /**
     * Requests the Read Phone state permission.
     * If the permission has been denied previously, a SnackBar will prompt the user to grant the
     * permission, otherwise it is requested directly.
     */
    private void requestReadPhoneStatePermission() {

        if (ActivityCompat.shouldShowRequestPermissionRationale(getActivity(),
                "android.permission.READ_PHONE_STATE")) {
            // Provide an additional rationale to the user if the permission was not granted
            // and the user would benefit from additional context for the use of the permission.
            // For example if the user has previously denied the permission.
            Snackbar.make(mLayout, R.string.permission_read_phone_state_rationale,
                    Snackbar.LENGTH_INDEFINITE)
                    .setAction(R.string.action_accept, new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            ActivityCompat.requestPermissions(getActivity(),
                                    new String[]{"android.permission.READ_PHONE_STATE"},
                                    REQUEST_READ_PHONE_STATE);
                        }
                    })
                    .show();
        } else {

            // Camera permission has not been granted yet. Request it directly.
            ActivityCompat.requestPermissions(getActivity(), new String[]{"android.permission.READ_PHONE_STATE"},
                    REQUEST_READ_PHONE_STATE);
        }
    }

    /*
        PRIVATE METHODS
     */

    /**
     * Check if a string is a valid sms code
     * @param strSmsCode
     * @return boolean
     */
    private boolean isValidSmsCode(String strSmsCode)
    {
        if (strSmsCode != null && !strSmsCode.isEmpty() && TextUtils.isDigitsOnly(strSmsCode) && strSmsCode.length() == 6)
        {
            return true;
        }
        else
        {
            UtilsApp.showAlertDialogBasic(
                    getActivity(),
                    getString(R.string.title_info),
                    getString(R.string.error_validation_sms_code)
            );
            return false;
        }
    }

    private String getGeneratedDeviceUuid()
    {
        final TelephonyManager tm = (TelephonyManager) getActivity().getBaseContext().getSystemService(Context.TELEPHONY_SERVICE);

        final String strTmDevice, strTmSerial, strAndroidId;
        strTmDevice = "" + tm.getDeviceId();
        strTmSerial = "" + tm.getSimSerialNumber();
        strAndroidId = "" + android.provider.Settings.Secure.getString(getContext().getContentResolver(), android.provider.Settings.Secure.ANDROID_ID);

        UUID deviceUuid = new UUID(strAndroidId.hashCode(), ((long)strTmDevice.hashCode() << 32) | strTmSerial.hashCode());
        String strDeviceUuid = deviceUuid.toString();

        return strDeviceUuid;
    }

    /**
     * Start app registration
     *
     * @param smsCode
     */
    private void startAppRegistration(String smsCode)
    {
        if (mGcmToken != null)
        {
            mRlyProgressBar.setVisibility(View.VISIBLE);
            AccessData accessData = new AccessData(getContext());
            MezuPnsPRSService mezuPnsPRSService = new MezuPnsPRSService(getContext());
            AsyncTask async = mezuPnsPRSService.createRegisterCall(
                    RegisterStepTwoFragment.this,
                    smsCode,
                    mGcmToken,
                    accessData.getUuidApp(),
                    mUuidDevice,
                    UtilsApp.getChnProvider(),
                    UtilsApp.getAppVersion(getContext()),
                    UtilsApp.getDevVendor(),
                    UtilsApp.getDevModel(),
                    UtilsApp.getOsVendor(),
                    UtilsApp.getOsVersion()
            );
            async.execute();
        }
    }

    private BroadcastReceiver createRegistrationBroadcastReceiver()
    {
        BroadcastReceiver registrationBroadcastReceiver = new BroadcastReceiver()
        {
            @Override
            public void onReceive(Context context, Intent intent)
            {
                if (getContext() == null)
                    return;
                AccessData accessData = new AccessData(getContext());
                boolean sentToken = accessData.isTokenPnsRegistered();
                String strGcmToken = intent.getStringExtra(Constants.GCM_TOKEN_PNS);
                if (sentToken && strGcmToken != null )
                {
                    mGcmToken = strGcmToken;
                    if (mUuidDevice != null)
                    {
                        String strSmsCode = mEtxtSmsCode.getText().toString().trim();
                        startAppRegistration(strSmsCode);
                    }
                }
                else if (!sentToken)
                {
                    UtilsApp.showAlertDialogBasic(
                            getActivity(),
                            getString(R.string.title_error),
                            getString(R.string.gcm_token_error)
                    );
                }
                else
                    UtilsLog.d(TAG, "token already sent");
            }
        };
        return registrationBroadcastReceiver;
    }

    private BroadcastReceiver createSmsBroadcastReceiver()
    {
        BroadcastReceiver smsReceiver = new BroadcastReceiver()
        {
            @Override
            public void onReceive(Context context, Intent intent)
            {
                // Retrieves a map of extended data from the intent.
                final Bundle bundle = intent.getExtras();
                try
                {
                    if (bundle != null)
                    {
                        Object[] aobjPdus = (Object[]) bundle.get("pdus");
                        for (int i = 0, len = aobjPdus.length; i < len; i++)
                        {
                            SmsMessage currentMessage;
                            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M)
                            {
                                String format = bundle.getString("format");
                                currentMessage = SmsMessage.createFromPdu((byte[]) aobjPdus[i], format);
                            } else
                                currentMessage = SmsMessage.createFromPdu((byte[]) aobjPdus[i]);

                            String strSender = currentMessage.getDisplayOriginatingAddress();

                            String strMessage = currentMessage.getDisplayMessageBody();
                            UtilsLog.d("SmsReceiver", "senderNum: " + strSender + "; message: " + strMessage);
                            if (strSender.equals(Constants.APPREGISRATION_SMS_SENDER_PHONE_NUMBER))
                            {
                                // Process sms text
                                String strSmsCode = strMessage.split(" ")[strMessage.length() - 1].replaceAll("\\D", "");
                                // Update UI and process message
                                mEtxtSmsCode.setText(strSmsCode);
                                startAppRegistration(strSmsCode);
                                break;
                            }
                        } // end for loop
                    } // bundle is null
                } catch (Exception e)
                {
                    Log.e("SMSReceiver", "Exception smsReceiver" + e);
                } finally
                {
                    // Unregister sms receiver
                    getContext().unregisterReceiver(RegisterStepTwoFragment.this.mSmsReceiver);
                    RegisterStepTwoFragment.this.mSmsReceiver = null;
                }
            }
        };
        return smsReceiver;
    }

    private void registerSmsService(BroadcastReceiver mSmsReceiver)
    {
        // Register the SMS broadcast receiver dinamically
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("android.provider.Telephony.SMS_RECEIVED");
        getContext().registerReceiver(mSmsReceiver, intentFilter);
    }

    /**
     * Check the device to make sure it has the Google Play Services APK. If
     * it doesn't, display a dialog that allows users to download the APK from
     * the Google Play Store or enable it in the device's system settings.
     */
    private boolean checkPlayServices()
    {
        GoogleApiAvailability apiAvailability = GoogleApiAvailability.getInstance();
        int resultCode = apiAvailability.isGooglePlayServicesAvailable(getActivity());
        if (resultCode != ConnectionResult.SUCCESS)
        {
            if (apiAvailability.isUserResolvableError(resultCode))
            {
                apiAvailability.getErrorDialog(getActivity(), resultCode, Constants.PLAY_SERVICES_RESOLUTION_REQUEST)
                        .show();
            }
            else
            {
                UtilsLog.i(RegisterActivity.TAG, "This device is not supported.");
                getActivity().finish();
            }
            return false;
        }
        return true;
    }


    @Override
    public void onPostRegisterAsyncTask(DTOResponseSimple response)
    {
        if (getContext() == null)
            return;

        if (response.getResult().equals(PNSHttpClient.RESPONSE_RESULT_OK))
        {
            AccessData accessData = new AccessData(getActivity());
            accessData.setGsm(mArgPhoneNumber);
            accessData.setUuidDevice(mUuidDevice);
            mListener.onRegisterStepTwoSuccess();
        }
        else
            UtilsApp.showAlertDialogBasic(
                    getActivity(),
                    getActivity().getString(R.string.title_error_with_code, response.getCode()),
                    response.getDescription()
            );

        if (mRlyProgressBar != null)
            mRlyProgressBar.setVisibility(View.GONE);
    }

    /**
     * Callback received when a permissions request has been completed.
     */
    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions,
                                           @NonNull int[] grantResults) {

        if (requestCode == REQUEST_READ_PHONE_STATE) {

            // Received permission result for Phone state permission.est.");
            // Check if the only required permission has been granted
            if (grantResults.length == 1 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                // Phone state permission has been granted, preview can be displayed
                Snackbar.make(mLayout, R.string.permision_available_read_phone_state,
                        Snackbar.LENGTH_SHORT).show();
            } else {
                Snackbar.make(mLayout, R.string.permissions_not_granted,
                        Snackbar.LENGTH_SHORT).show();

            }
        }
    }
}