package com.ejgv.gvi;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.util.Log;

import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class SMSReceiver extends BroadcastReceiver
{
    private static final String TAG = "SMSReceiver";

    private String mPhoneNumber;

    public SMSReceiver(String phoneNumber)
    {
        mPhoneNumber = phoneNumber;
    }

    @Override
    public void onReceive(Context context, Intent intent)
    {
        // Retrieves a map of extended data from the intent.
        final Bundle bundle = intent.getExtras();

        try
        {

            if (bundle != null)
            {
                Object[] pdusObj = (Object[]) bundle.get("pdus");

                for (int i = 0; i < pdusObj.length; i++)
                {
                    SmsMessage currentMessage = SmsMessage.createFromPdu((byte[]) pdusObj[i]);
                    String phoneNumber = currentMessage.getDisplayOriginatingAddress();

                    String senderNum = phoneNumber;
                    String message = currentMessage.getDisplayMessageBody();

                    /*String strMsgBody = currentMessage.getMessageBody().toString();
                    String strMsgSrc = currentMessage.getOriginatingAddress();*/

                    UtilsLog.d("SmsReceiver", "senderNum: " + senderNum + "; message: " + message);


                    if (phoneNumber.equals(mPhoneNumber))
                    {
                        // Notify UI that registration has completed, so the progress indicator can be hidden.

                    }

                } // end for loop
            } // bundle is null

        }
        catch (Exception e)
        {
            Log.e("SMSReceiver", "Exception smsReceiver" +e);
        }
    }
}