package com.ejgv.gvi.adapters;

import android.content.Context;
import android.support.v7.widget.AppCompatTextView;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;

import com.ejgv.gvi.R;

import java.util.List;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class TagsFilterAdapter extends ArrayAdapter<String>
{
    Context mContext;
    String[] mData;

    public TagsFilterAdapter(Context context, int resource) {
        super(context, resource);
    }

    public TagsFilterAdapter(Context context, int resource, int textViewResourceId) {
        super(context, resource, textViewResourceId);
        mContext = context;
    }

    public TagsFilterAdapter(Context context, int resource, String[] objects) {
        super(context, resource, objects);
        mContext = context;
        mData = objects;
    }

    public TagsFilterAdapter(Context context, int resource, int textViewResourceId, String[] objects) {
        super(context, resource, textViewResourceId, objects);
        mContext = context;
        mData = objects;
    }

    public TagsFilterAdapter(Context context, int resource, List<String> objects) {
        super(context, resource, objects);
        mContext = context;
        mData = objects.toArray(new String[objects.size()]);
    }

    public TagsFilterAdapter(Context context, int resource, int textViewResourceId, List<String> objects) {
        super(context, resource, textViewResourceId, objects);
        mContext = context;
        mData = objects.toArray(new String[objects.size()]);
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent)
    {
        View view = super.getView(position, convertView, parent);
        view.setBackgroundResource(R.drawable.bg_message_inbox_item);
        if (mData[position] == null || mData[position].isEmpty())
            ((AppCompatTextView) view).setText(mContext.getResources().getString(R.string.tag_empty));
        else
            ((AppCompatTextView) view).setText(mData[position]);
        return view;
    }
}
