package com.ejgv.gvi.adapters;

import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;

import com.ejgv.gvi.Constants;
import com.ejgv.gvi.NewsFragment;
import com.ejgv.gvi.utils.UtilsApp;

/**
 * Created by Eneko on 21/7/15.
 */
public class ViewPagerAdapter extends FragmentStatePagerAdapter {

    CharSequence Titles[]; // This will Store the Titles of the Tabs which are Going to be passed when ViewPagerAdapter is created
    int NumbOfTabs; // Store the number of tabs, this will also be passed when the ViewPagerAdapter is created
    Context mContext;

    // Build a Constructor and assign the passed Values to appropriate values in the class
    public ViewPagerAdapter(FragmentManager fm, CharSequence mTitles[], int mNumbOfTabsumb, Context context) {
        super(fm);

        this.Titles = mTitles;
        this.NumbOfTabs = mNumbOfTabsumb;
        this.mContext = context;
    }

    //This method return the fragment for the every position in the View Pager
    @Override
    public Fragment getItem(int position) {

        NewsFragment newsFragment =new NewsFragment();
        Bundle args = new Bundle();

        if(position == 0) // if the position is 0 we are returning the First tab
        {
            if (UtilsApp.getLocale(mContext).equals("es")) {
                args.putString(Constants.PARAM_RSS_FEED, Constants.SCHOLARSHIP_OUTSOURCING_RSS_FEED_URL_ES);
            } else {
                args.putString(Constants.PARAM_RSS_FEED, Constants.SCHOLARSHIP_OUTSOURCING_RSS_FEED_URL_EU);
            }

        }
        else             // As we are having 2 tabs if the position is now 0 it must be 1 so we are returning second tab
        {
            if (UtilsApp.getLocale(mContext).equals("es")) {
                args.putString(Constants.PARAM_RSS_FEED, Constants.BOOKING_RSS_FEED_URL_ES);
            } else {
                args.putString(Constants.PARAM_RSS_FEED, Constants.BOOKING_RSS_FEED_URL_EU);
            }
        }

        newsFragment.setArguments(args);

        return newsFragment;
    }

    // This method return the titles for the Tabs in the Tab Strip

    @Override
    public CharSequence getPageTitle(int position) {
        return Titles[position];
    }

    // This method return the Number of tabs for the tabs Strip

    @Override
    public int getCount() {
        return NumbOfTabs;
    }
}
