package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class AddMessageResponsedRunnable implements Runnable
{
    private static final String TAG = "AddMsgResponsedRunnable";

    private SQLiteOpenHelper databaseHelper;
    private String trans_id;
    private String responsedCode;
    private long tsResponse;

    public AddMessageResponsedRunnable()
    {
    }

    public AddMessageResponsedRunnable(SQLiteOpenHelper databaseHelper,
                                       String trans_id, String responsedCode, long tsResponse)
    {
        this.databaseHelper = databaseHelper;
        this.trans_id = trans_id;
        this.responsedCode = responsedCode;
        this.tsResponse = tsResponse;
    }

    @Override
    public void run()
    {
        try
        {
            insertMessageResponsed();
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in run", e);
            UtilsApp.sendTraceToServer(UtilsApp.createStandardAddTraceParams(getClass().getName(), "run", e));
        }
    }

    private void insertMessageResponsed() throws Exception
    {
        DAOMsgResponsed daoMsgResponsed =
                new DAOMsgResponsed(databaseHelper);

        long id = daoMsgResponsed.update(trans_id, responsedCode);

        if (id == -1)
            daoMsgResponsed.insert(trans_id, responsedCode, tsResponse);
    }
}