package com.ejgv.gvi.dao;

import android.content.ContentValues;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.restapipns.dto.DTOPnsMsgPrivateResponseValues;

/**
 * Created by koldo on 20/01/16.
 */
public class DAOMsgResponseValue implements DAOService.DAOMsgResponseValueInterface
{
    private SQLiteOpenHelper mDatabaseHelper;

    public DAOMsgResponseValue(SQLiteOpenHelper databaseHelper)
    {
        mDatabaseHelper = databaseHelper;
    }

    /**
     *
     * @param trans_id
     * @param value
     * @return
     * @throws Exception
     */
    @Override
    public long insert(String trans_id, DTOPnsMsgPrivateResponseValues value) throws Exception
    {
        ContentValues values = new ContentValues();
        values.put(TableMsgResponseValue.Columns.ID_TRANS, trans_id);
        values.put(TableMsgResponseValue.Columns.CODE, value.getCode());
        values.put(TableMsgResponseValue.Columns.VALUE_EU, value.getEu());
        values.put(TableMsgResponseValue.Columns.VALUE_ES, value.getEs());

        long insertId = mDatabaseHelper.getWritableDatabase().insertWithOnConflict(
                TableMsgResponseValue.Table.NAME,
                null,
                values,
                SQLiteDatabase.CONFLICT_IGNORE
        );
        return insertId;
    }

    /**
     *
     * @param trans_id
     * @param values
     * @return
     * @throws Exception
     */
    @Override
    public long[] insert(String trans_id, DTOPnsMsgPrivateResponseValues[] values) throws Exception
    {
        long[] alng_insertId = new long[values.length];

        for (int i=0, len=alng_insertId.length; i<len; i++)
        {
            alng_insertId[i] = insert(trans_id, values[i]);
        }

        return alng_insertId;
    }

    /**
     *
     * @return
     * @throws Exception
     */
    @Override
    public long delete() throws Exception
    {
        long deleteId = mDatabaseHelper.getWritableDatabase().delete(
                TableMsgResponseValue.Table.NAME,
                null,
                null
        );
        return deleteId;
    }

    /**
     *
     * @param trans_id
     * @param code
     * @return
     * @throws Exception
     */
    @Override
    public long delete(String trans_id, String code) throws Exception
    {
        String selection = new StringBuilder()
                .append(TableMsgResponseValue.Columns.ID_TRANS).append("=? ")
                .append("AND ")
                .append(TableMsgResponseValue.Columns.CODE).append("=?")
                .toString();

        String[] selectionArgs = { trans_id, code};

        long deleteId = mDatabaseHelper.getWritableDatabase().delete(
                TableMsgResponseValue.Table.NAME,
                selection,
                selectionArgs
        );
        return deleteId;
    }

}