package com.ejgv.gvi.dao;

import android.content.ContentValues;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.Date;

/**
 * Created by koldo on 20/01/16.
 */
public class DAOMsgResponsed implements DAOService.DAOMsgResponsedInterface
{
    private SQLiteOpenHelper mDatabaseHelper;

    public DAOMsgResponsed(SQLiteOpenHelper databaseHelper)
    {
        mDatabaseHelper = databaseHelper;
    }

    /**
     *
     * @param trans_id
     * @param responseCode
     * @param tsResponse
     * @return
     * @throws Exception
     */
    @Override
    public long insert(String trans_id, String responseCode, long tsResponse) throws Exception
    {
        ContentValues values = new ContentValues();
        values.put(TableMsgResponsed.Columns.ID_TRANS, trans_id);
        values.put(TableMsgResponsed.Columns.CODE, responseCode);
        values.put(TableMsgResponsed.Columns.TS_RESPONSE, tsResponse);

        long insertId = mDatabaseHelper.getWritableDatabase().insert(
                TableMsgResponsed.Table.NAME,
                null,
                values
        );
        return insertId;
    }

    /**
     *
     * @param trans_id
     * @param responseCode
     * @return
     * @throws Exception
     */
    @Override
    public long update(String trans_id, String responseCode) throws Exception
    {
        ContentValues values = new ContentValues();
        values.put(TableMsgResponsed.Columns.CODE, responseCode);
        values.put(TableMsgResponsed.Columns.TS_RESPONSE, new Date().getTime());

        String selection = new StringBuilder()
                .append(TableMsgResponsed.Columns.ID_TRANS)
                .append("=?")
                .toString();

        String[] selectionArgs = { trans_id };

        long updateId = mDatabaseHelper.getWritableDatabase().update(
                TableMsgResponsed.Table.NAME,
                values,
                selection,
                selectionArgs
        );

        return updateId;
    }

    /**
     *
     * @return
     * @throws Exception
     */
    @Override
    public long delete() throws Exception
    {
        long deleteId = mDatabaseHelper.getWritableDatabase().delete(
                TableMsgResponsed.Table.NAME,
                null,
                null
        );
        return deleteId;
    }

    /**
     *
     * @param trans_id
     * @return
     * @throws Exception
     */
    @Override
    public long delete(String trans_id) throws Exception
    {
        String selection = new StringBuilder()
                .append(TableMsgResponsed.Columns.ID_TRANS)
                .append("=? ")
                .toString();

        String[] selectionArgs = { trans_id };

        long deleteId = mDatabaseHelper.getWritableDatabase().delete(
                TableMsgResponsed.Table.NAME,
                selection,
                selectionArgs
        );
        return deleteId;
    }
}