package com.ejgv.gvi.dao;

import android.database.Cursor;
import android.database.sqlite.SQLiteOpenHelper;

/**
 * Created by koldo on 22/12/15.
 */
public class DAOVirtualTags implements DAOService.DAOVirtualTagsInterface
{
    private SQLiteOpenHelper mDatabaseHelper;

    public DAOVirtualTags(SQLiteOpenHelper databaseHelper)
    {
        mDatabaseHelper = databaseHelper;
    }

    /**
     *
     * @throws Exception
     */
    @Override
    public void populate(String languageName) throws Exception
    {
        String strTagColumn = TableVirtualTags.Columns.TAG + languageName.substring(0, 1).toUpperCase() + languageName.substring(1).toLowerCase();
        delete();
        String populate = new StringBuilder()
                .append("INSERT INTO ").append(TableVirtualTags.Table.NAME)
                .append(" SELECT DISTINCT ").append(strTagColumn). append(" FROM ").append(TableMessage.Table.NAME).append(";")
                //.append(" WHERE ").append(strTagColumn).append(" IS NOT NULL;")
                .toString();

        mDatabaseHelper.getWritableDatabase().execSQL(populate);
    }
    
    /**
     *
     *
     * @return
     * @throws Exception
     */
    @Override
    public long delete() throws Exception
    {
        long deleteId = mDatabaseHelper.getWritableDatabase().delete(
                TableVirtualTags.Table.NAME,
                null,
                null
        );
        return deleteId;
    }

    /**
     *
     * @param tag
     * @return
     * @throws Exception
     */
    /*@Override
    public long delete(String tag) throws Exception
    {
        String selection = new StringBuilder()
                .append(TableVirtualTags.Columns.TAG)
                .append("=?")
                .toString();

        String[] selectionArgs = { tag };

        long deleteId = mDatabase.delete(
                TableVirtualTags.Table.NAME,
                selection,
                selectionArgs
        );
        return deleteId;
    }*/

    /**
     *
     * @return
     * @throws Exception
     */
    @Override
    public String[] selectTags() throws Exception
    {
        String[] projection = {
                "DISTINCT "+ TableVirtualTags.Columns.TAG
        };

        String orderBy = new StringBuilder()
                .append(TableVirtualTags.Columns.TAG)
                .toString();

        return query(projection, null, null, orderBy);
    }

    /**
     *
     * @param query
     * @return
     * @throws Exception
     */
    @Override
    public String[] selectTagsMatch(String query) throws Exception
    {
        String[] projection = {
                TableVirtualTags.Columns.TAG
        };

        String selection = new StringBuilder()
                .append(TableVirtualTags.Columns.TAG)
                .append(" MATCH ?")
                .toString();

        String[] selectionArgs = { query+"*" };

        String orderBy = new StringBuilder()
                .append(TableVirtualTags.Columns.TAG)
                .toString();

        return query(projection, selection, selectionArgs, orderBy);
    }

    private String[] query(String[] projection, String selection, String[] selectionArgs, String orderBy) throws Exception
    {
        Cursor cursor = mDatabaseHelper.getReadableDatabase().query(
                TableVirtualTags.Table.NAME,
                projection,
                selection,
                selectionArgs,
                null,
                null,
                orderBy
        );

        if (cursor == null)
        {
            return null;
        }
        else if (!cursor.moveToFirst())
        {
            cursor.close();
            return new String[0];
        }
        else
        {
            String[] tags = new String[cursor.getCount()];
            int count = 0;
            while (cursor.isAfterLast() == false)
            {
                tags[count] = (cursor.getString(0) != null) ? cursor.getString(0) : "";
                count++;
                cursor.moveToNext();
            }
            cursor.close();
            return tags;
        }
    }
}