package com.ejgv.gvi.dao;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class DDBBHelper extends SQLiteOpenHelper
{
    private static final String LOG_TAG = "DDBBHelper";
    private static final int DATABASE_VERSION = 1;
    private static final String DATABASE_NAME = "mezu.db";

    // Constructors
    public DDBBHelper(Context context)
    {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onConfigure(SQLiteDatabase db)
    {
        db.execSQL("PRAGMA foreign_keys = 1;");
        db.execSQL("PRAGMA recursive_triggers = 1;");

        super.onConfigure(db);
    }

    @Override
    public void onCreate(SQLiteDatabase db)
    {
        db.execSQL(TableMessage.CREATE_TABLE);
        db.execSQL(TableMsgResponseValue.CREATE_TABLE);
        db.execSQL(TableMsgResponsed.CREATE_TABLE);
        db.execSQL((TableMsgResponsed.CREATE_INDEXES));
        db.execSQL(TableMsgPendingOperation.CREATE_TABLE);
        db.execSQL(TableMsgPendingOperation.CREATE_TRIGGERS);
        db.execSQL(TableVirtualTags.CREATE_TABLE);

        UtilsLog.d(LOG_TAG, TableMessage.CREATE_TABLE);
        UtilsLog.d(LOG_TAG, TableMsgResponseValue.CREATE_TABLE);
        UtilsLog.d(LOG_TAG, TableMsgResponsed.CREATE_TABLE);
        UtilsLog.d(LOG_TAG, TableMsgResponsed.CREATE_INDEXES);
        UtilsLog.d(LOG_TAG, TableMsgPendingOperation.CREATE_TABLE);
        UtilsLog.d(LOG_TAG, TableMsgPendingOperation.CREATE_TRIGGERS);
        UtilsLog.d(LOG_TAG, TableVirtualTags.CREATE_TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion)
    {
        //TODO: upgrade sentences
    }

    @Override
    public void onDowngrade(SQLiteDatabase db, int oldVersion, int newVersion)
    {
        //TODO: downgrade sentences
    }
}