package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class DeleteMessagesOverLimitRunnable implements Runnable
{
    private static final String TAG = "AddMsgResponsedRunnable";

    private SQLiteOpenHelper databaseHelper;
    private int messagesLimit;

    public DeleteMessagesOverLimitRunnable()
    {
    }

    public DeleteMessagesOverLimitRunnable(SQLiteOpenHelper databaseHelper, int messagesLimit)
    {
        this.databaseHelper = databaseHelper;
        this.messagesLimit = messagesLimit;
    }

    @Override
    public void run()
    {
        try
        {
            deleteMessagesOverLimit(messagesLimit);
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in run", e);
            UtilsApp.sendTraceToServer(UtilsApp.createStandardAddTraceParams(getClass().getName(), "run", e));
        }
    }

    private void deleteMessagesOverLimit(int limit) throws Exception
    {
        DAOMessage daoMessage = new DAOMessage(databaseHelper);
        long deleted_ids = daoMessage.deleteOver(limit);
        UtilsLog.d("DelMsgsOverLimit", String.valueOf(deleted_ids));
    }
}