package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;
import android.text.TextUtils;

import com.ejgv.gvi.Constants;
import com.ejgv.gvi.dao.dto.DTOPnsMsgOperation;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class DeleteMessagesRunnable implements Runnable
{
    private static final String TAG = "AddMsgResponsedRunnable";

    private SQLiteOpenHelper databaseHelper;
    private String[] trans_ids;

    public DeleteMessagesRunnable()
    {
    }

    public DeleteMessagesRunnable(SQLiteOpenHelper databaseHelper, String[] trans_ids)
    {
        this.databaseHelper = databaseHelper;
        this.trans_ids = trans_ids;
    }

    @Override
    public void run()
    {
        try
        {
            if (trans_ids.length == 1)
            {
                insertMsgPendingOperation(Constants.PNS_MESSAGE_OPERATION_DELETE, trans_ids[0]);
                deleteMessage(trans_ids[0]);
            }
            else
            {
                insertMsgPendingOperations(Constants.PNS_MESSAGE_OPERATION_DELETE, trans_ids);
                deleteMessages(trans_ids);
            }
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in run", e);
            UtilsApp.sendTraceToServer(UtilsApp.createStandardAddTraceParams(getClass().getName(), "run", e));
        }
    }

    private void insertMsgPendingOperation(char operation, String trans_id) throws Exception
    {
        DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(databaseHelper);
        daoMsgPendingOperation.insert(createDTOMsgPendingOperation(trans_id, operation));
    }

    private DTOPnsMsgOperation createDTOMsgPendingOperation(String trans_id, char operation)
    {
        DTOPnsMsgOperation dtoPnsMsgOperation = new DTOPnsMsgOperation();
        dtoPnsMsgOperation.setIdTrans(trans_id);
        dtoPnsMsgOperation.setMsgOperation(operation);
        return dtoPnsMsgOperation;
    }

    private void deleteMessage(String trans_id) throws Exception
    {
        DAOMessage daoMessage = new DAOMessage(databaseHelper);
        daoMessage.delete(trans_id);
    }

    private void insertMsgPendingOperations(char operation, String[] trans_ids) throws Exception
    {
        DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(databaseHelper);
        daoMsgPendingOperation.insertOperations(operation, trans_ids);
    }

    private void deleteMessages(String[] trans_ids) throws Exception
    {
        DAOMessage daoMessage = new DAOMessage(databaseHelper);
        daoMessage.delete(trans_ids);
        UtilsLog.d("createDeleteMesgCall", TextUtils.join(",", trans_ids));
    }
}