package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.dao.dto.DTOPnsMsgOperation;

/**
 * Created by koldo on 15/02/16.
 */
public class DeleteMsgPendingOperationsRunnable implements Runnable
{
    private static final String TAG = "MarkAsReadRunnable";

    private SQLiteOpenHelper databaseHelper;
    private String[] trans_ids;
    private char operation;

    public DeleteMsgPendingOperationsRunnable()
    {
    }

    public DeleteMsgPendingOperationsRunnable(SQLiteOpenHelper databaseHelper,
                                              char operation, String trans_id)
    {
        this.databaseHelper = databaseHelper;
        this.operation = operation;
        this.trans_ids = new String[]{trans_id};
    }

    public DeleteMsgPendingOperationsRunnable(SQLiteOpenHelper databaseHelper,
                                              char operation, String[] trans_ids)
    {
        this.databaseHelper = databaseHelper;
        this.operation = operation;
        this.trans_ids = trans_ids;
    }

    @Override
    public void run()
    {
        try
        {
            if (trans_ids.length == 1)
                deleteMsgPendingOperation(operation, trans_ids[0]);
            else
                deleteMsgPendingOperations(operation, trans_ids);
        }
        catch (Exception e)
        {
        }
    }

    private void deleteMsgPendingOperation(char operation, String trans_id) throws Exception
    {
        DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(databaseHelper);
        daoMsgPendingOperation.deleteOperation(createDTOMsgPendingOperation(trans_id, operation));
    }

    private DTOPnsMsgOperation createDTOMsgPendingOperation(String trans_id, char operation)
    {
        DTOPnsMsgOperation dtoPnsMsgOperation = new DTOPnsMsgOperation();
        dtoPnsMsgOperation.setIdTrans(trans_id);
        dtoPnsMsgOperation.setMsgOperation(operation);
        return dtoPnsMsgOperation;
    }

    private void deleteMsgPendingOperations(char operation, String[] trans_ids) throws Exception
    {
        DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(databaseHelper);
        daoMsgPendingOperation.deleteOperations(operation, trans_ids);
    }
}