package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;
import android.os.AsyncTask;

import com.ejgv.gvi.dao.dto.DTOPnsMsgOperation;
import com.ejgv.gvi.dao.dto.DTOResponseMsgPendingOperations;

/**
 * Created by koldo on 20/01/16.
 */
public class GetMsgPendingOperationsAsyncTask extends AsyncTask<Object, Void, DTOResponseMsgPendingOperations>
{
    private SQLiteOpenHelper mDatabaseHelper;
    private DAOService.OnGetMsgPendingOperationsListener mListener;

    /**
     * Constructor
     *
     * @param databaseHelper
     * @param listener
     */
    public GetMsgPendingOperationsAsyncTask(SQLiteOpenHelper databaseHelper, DAOService.OnGetMsgPendingOperationsListener listener)
    {
        this.mDatabaseHelper = databaseHelper;
        this.mListener = listener;
    }

    /**
     * AddMessagesAsyncTask UI background processing
     *
     * @param params
     * @return DTOResponseSimple
     */
    @Override
    protected DTOResponseMsgPendingOperations doInBackground(Object... params)
    {
        DTOResponseMsgPendingOperations objResponse = new DTOResponseMsgPendingOperations();
        try
        {
            // DDBB call
            DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(mDatabaseHelper);
            DTOPnsMsgOperation[] operations = daoMsgPendingOperation.selectPendingOperations();

            objResponse.setResult(DAOService.RESPONSE_RESULT_OK);
            objResponse.setOperations(operations);
        }
        catch (Exception e)
        {
            objResponse.setResult(DAOService.RESPONSE_RESULT_ERROR);
            objResponse.setCode(DAOService.DDBB_ERROR_CODE + DAOService.DDBB_ERROR);
            e.printStackTrace();
        }
        finally
        {
            return objResponse;
        }
    }

    /**
     * AddMessagesAsyncTask UI main processing after its execution
     *
     * @param response
     */
    @Override
    protected void onPostExecute(DTOResponseMsgPendingOperations response)
    {
        if (mListener != null && !isCancelled())
            mListener.onPostGetMsgPendingOperationsAsyncTask(response);
    }

}
