package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;

import com.ejgv.gvi.Constants;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class MarkAsReadRunnable implements Runnable
{
    private static final String TAG = "MarkAsReadRunnable";

    private SQLiteOpenHelper databaseHelper;
    private String trans_id;

    public MarkAsReadRunnable()
    {
    }

    public MarkAsReadRunnable(SQLiteOpenHelper databaseHelper, String trans_id)
    {
        this.databaseHelper = databaseHelper;
        this.trans_id = trans_id;
    }

    @Override
    public void run()
    {
        try
        {
            insertMarkAsReadPendingOperation(trans_id);
            updateMessageTsReadColumn(trans_id);
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in run", e);
            UtilsApp.sendTraceToServer(UtilsApp.createStandardAddTraceParams(getClass().getName(), "run", e));
        }
    }

    private void insertMarkAsReadPendingOperation(String trans_id) throws Exception
    {
        DAOMsgPendingOperation daoMsgPendingOperation = new DAOMsgPendingOperation(databaseHelper);
        daoMsgPendingOperation.insertOperations(Constants.PNS_MESSAGE_OPERATION_MARK_AS_READ, new String[]{trans_id});
    }

    private void updateMessageTsReadColumn(String trans_id) throws Exception
    {
        DAOMessage daoMessage = new DAOMessage(databaseHelper);
        daoMessage.updateTsRead(trans_id);
    }

}