package com.ejgv.gvi.dao;

import android.database.sqlite.SQLiteOpenHelper;
import android.os.AsyncTask;

import com.ejgv.gvi.restapipns.dto.DTOResponseSimple;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
class PopulateTagsAsyncTask extends AsyncTask<Object, Void, DTOResponseSimple>
{
    private static final String TAG = "PopulateTagsAsyncTask";

    private SQLiteOpenHelper mDatabaseHelper;
    private DAOService.OnPopulateTagsListener mListener;

    private String mLanguageName;

    /**
     *  @param databaseHelper
     * @param listener
     * @param languageName
     */
    public PopulateTagsAsyncTask(SQLiteOpenHelper databaseHelper, DAOService.OnPopulateTagsListener listener, String languageName)
    {
        mDatabaseHelper = databaseHelper;
        mListener = listener;
        mLanguageName = languageName;
    }

    /**
     * DeleteAsyncTask UI background processing
     * @param params
     * @return DTOResponseSimple
     */
    @Override
    protected DTOResponseSimple doInBackground(Object... params)
    {
        DTOResponseSimple objResponse = new DTOResponseSimple();
        try
        {

            // DDBB call
            DAOVirtualTags daoVirtualTags = new DAOVirtualTags(mDatabaseHelper);
            daoVirtualTags.populate(mLanguageName);

            objResponse.setResult(DAOService.RESPONSE_RESULT_OK);
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in doInBackground", e);
            UtilsApp.sendTraceToServer(UtilsApp.createStandardAddTraceParams(getClass().getName(), "doInBackground", e));
            objResponse.setResult(DAOService.RESPONSE_RESULT_ERROR);
            objResponse.setCode(DAOService.DDBB_ERROR_CODE + DAOService.DDBB_ERROR);
        }
        finally
        {
            return objResponse;
        }
    }

    /**
     * DeleteAsyncTask UI main processing after its execution
     * @param response
     */
    @Override
    protected void onPostExecute(DTOResponseSimple response)
    {
        if (mListener != null && !isCancelled())
            mListener.onPostPopulateTagsAsyncTask(response);
    }

}