package com.ejgv.gvi.dialogs;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AlertDialog;
import android.widget.ArrayAdapter;
import android.widget.ListAdapter;

import com.ejgv.gvi.R;

public class SetCodeNameSingleChoiceDialogFragment extends DialogFragment implements OnClickListener
{
    private static final String ARG_NAME_RESOURCE_ID = "RESOURCE_ID";
    private static final String ARG_NAME_TITLE = "TITLE";
    private static final String ARG_NAME_CODE_ARRAY = "CODE_ARRAY";
    private static final String ARG_NAME_NAME_ARRAY = "NAME_ARRAY";
    private static final String ARG_NAME_SELECTED_ITEM_POS = "SELECTED_ITEM_POS";
	private String[] mCodes;
	private String[] mNames;
    public static final String RESULT_PARAM_CODE = "CODE";
    public static final String RESULT_PARAM_NAME = "NAME";

	public static SetCodeNameSingleChoiceDialogFragment newInstance(String strTitle, String[] astrCode, String[] astrName )
	{
		SetCodeNameSingleChoiceDialogFragment dialog = new SetCodeNameSingleChoiceDialogFragment();
        Bundle args = new Bundle();
        args.putString(ARG_NAME_TITLE, strTitle);
        args.putStringArray(ARG_NAME_CODE_ARRAY, astrCode);
        args.putStringArray(ARG_NAME_NAME_ARRAY, astrName);
        args.putInt(ARG_NAME_SELECTED_ITEM_POS, -1);
        dialog.setArguments(args);
        return dialog;
    }

    public static SetCodeNameSingleChoiceDialogFragment newInstance(int resourceId, String strTitle, String[] astrCode, String[] astrName )
    {
        SetCodeNameSingleChoiceDialogFragment dialog = new SetCodeNameSingleChoiceDialogFragment();
        Bundle args = new Bundle();
        args.putInt(ARG_NAME_RESOURCE_ID, resourceId);
        args.putString(ARG_NAME_TITLE, strTitle);
        args.putStringArray(ARG_NAME_CODE_ARRAY, astrCode);
        args.putStringArray(ARG_NAME_NAME_ARRAY, astrName);
        args.putInt(ARG_NAME_SELECTED_ITEM_POS, -1);
        dialog.setArguments(args);
        return dialog;
    }

    public static SetCodeNameSingleChoiceDialogFragment newInstance(String strTitle, String[] astrCode,
                                                        String[] astrName, int intSelectedItem )
    {
        SetCodeNameSingleChoiceDialogFragment dialog = new SetCodeNameSingleChoiceDialogFragment();
        Bundle args = new Bundle();
        args.putString(ARG_NAME_TITLE, strTitle);
        args.putStringArray(ARG_NAME_CODE_ARRAY, astrCode);
        args.putStringArray(ARG_NAME_NAME_ARRAY, astrName);
        args.putInt(ARG_NAME_SELECTED_ITEM_POS, intSelectedItem);
        dialog.setArguments(args);
        return dialog;
    }

    public static SetCodeNameSingleChoiceDialogFragment newInstance(int resourceId, String strTitle, String[] astrCode,
                                                                    String[] astrName, int intSelectedItem )
    {
        SetCodeNameSingleChoiceDialogFragment dialog = new SetCodeNameSingleChoiceDialogFragment();
        Bundle args = new Bundle();
        args.putInt(ARG_NAME_RESOURCE_ID, resourceId);
        args.putString(ARG_NAME_TITLE, strTitle);
        args.putStringArray(ARG_NAME_CODE_ARRAY, astrCode);
        args.putStringArray(ARG_NAME_NAME_ARRAY, astrName);
        args.putInt(ARG_NAME_SELECTED_ITEM_POS, intSelectedItem);
        dialog.setArguments(args);
        return dialog;
    }
	
	@Override
    public Dialog onCreateDialog(Bundle savedInstanceState)
	{
		AlertDialog.Builder builder = new AlertDialog.Builder(getContext());

		// GET PARAMS
        int txtResourceId = getArguments().getInt(ARG_NAME_RESOURCE_ID);
		String str_title = getArguments().getString(ARG_NAME_TITLE);
        mCodes = getArguments().getStringArray(ARG_NAME_CODE_ARRAY);
        mNames = getArguments().getStringArray(ARG_NAME_NAME_ARRAY);
        int selectedItemPos = getArguments().getInt(ARG_NAME_SELECTED_ITEM_POS);

        builder.setTitle(str_title);

        if (txtResourceId > 0)
        {
            ListAdapter adapter = new ArrayAdapter<>(getContext(),
                    txtResourceId, mNames);
            builder.setSingleChoiceItems(adapter, selectedItemPos, this);
        }
        else
            builder.setSingleChoiceItems(mNames, selectedItemPos, this);

        builder.setNegativeButton(R.string.action_cancel, null);

	    return builder.create();
    }

	@Override
	public void onClick(DialogInterface dialog, int which)
	{
        Intent i = new Intent()
                .putExtra(RESULT_PARAM_CODE, mCodes[which])
                .putExtra(RESULT_PARAM_NAME, mNames[which]);
        getTargetFragment().onActivityResult(getTargetRequestCode(), Activity.RESULT_OK, i);
        dialog.dismiss();
	}
}