package com.ejgv.gvi.dmo;

import android.os.Parcel;
import android.os.Parcelable;

import com.ejgv.gvi.dao.dto.DTOMessage;
import com.ejgv.gvi.restapipns.dto.DTOPnsMsgPrivate;
import com.ejgv.gvi.restapipns.dto.DTOText;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class DMOMessage extends DTOMessage implements Parcelable
{
    public DMOMessage()
    {
    }

    public DMOMessage(DTOMessage dtoMessage)
    {
        super(
                dtoMessage.getIdTrans(),
                dtoMessage.getPublicText(),
                dtoMessage.getPrivateMsg(),
                dtoMessage.getTs(),
                dtoMessage.getTsRead(),
                dtoMessage.getTsResponse(),
                dtoMessage.getResponseCode(),
                dtoMessage.getResponseText()
        );
    }

    public DMOMessage(String idTrans, String publicText, DTOPnsMsgPrivate privateMsg, long ts,
                      long tsRead, long tsResponse, String responseCode, DTOText responseText)
    {
        super(idTrans, publicText, privateMsg, ts, tsRead, tsResponse, responseCode, responseText);
    }

    protected DMOMessage(Parcel in)
    {
        setIdTrans(in.readString());
        setPublicText(in.readString());
        setPrivateMsg((DTOPnsMsgPrivate) in.readParcelable(DMOPnsMsgPrivate.class.getClassLoader()));
        setTs(in.readLong());
        setTsRead(in.readLong());
        setTsResponse(in.readLong());
        setResponseCode(in.readString());
    }

    public static final Creator<DMOMessage> CREATOR = new Creator<DMOMessage>()
    {
        @Override
        public DMOMessage createFromParcel(Parcel in)
        {
            return new DMOMessage(in);
        }

        @Override
        public DMOMessage[] newArray(int size)
        {
            return new DMOMessage[size];
        }
    };

    @Override
    public int describeContents()
    {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags)
    {
        dest.writeString(getIdTrans());
        dest.writeString(getPublicText());
        if (getPrivateMsg() != null)
            dest.writeParcelable(new DMOPnsMsgPrivate(getPrivateMsg()), flags);
        else
            dest.writeParcelable(null, flags);
        dest.writeLong(getTs());
        dest.writeLong(getTsRead());
        dest.writeLong(getTsResponse());
        dest.writeString(getResponseCode());
    }
}