package com.ejgv.gvi.listeners;

import android.graphics.Canvas;
import android.support.v7.widget.RecyclerView;
import android.support.v7.widget.helper.ItemTouchHelper;
import android.view.Gravity;
import android.view.View;
import android.widget.TextView;

import com.ejgv.gvi.adapters.MessageListAdapter;

/**
 * Created by koldo on 20/12/15.
 */
public class MessageInboxItemTouchHelper extends ItemTouchHelper.SimpleCallback

{
    private static final String TAG = "ItemTouchHelper";

    private OnRecyclerItemTouchHelperListener mListener;

    public interface OnRecyclerItemTouchHelperListener
    {
        void onMessageInboxItemSwiped(int position);
    }

    public MessageInboxItemTouchHelper(OnRecyclerItemTouchHelperListener listener)
    {
        super(0, ItemTouchHelper.LEFT | ItemTouchHelper.RIGHT);
        mListener = listener;
    }

    @Override
    public boolean onMove(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, RecyclerView.ViewHolder target)
    {
        return false;
    }

    @Override
    public void onSwiped(RecyclerView.ViewHolder viewHolder, int direction)
    {
        viewHolder.setIsRecyclable(true);
        mListener.onMessageInboxItemSwiped(viewHolder.getAdapterPosition());
    }

    @Override
    public void clearView(RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder)
    {
        TextView vNoSwipable = ((MessageListAdapter.ViewHolder) viewHolder).getNoSwipableView();
        vNoSwipable.setHeight(0);
        super.clearView(recyclerView, viewHolder);
    }

    @Override
    public void onSelectedChanged(RecyclerView.ViewHolder viewHolder, int actionState)
    {
        if (viewHolder != null)
            super.onSelectedChanged(viewHolder, actionState);
    }

    @Override
    public void onChildDraw(Canvas c, RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, float dX, float dY, int actionState, boolean isCurrentlyActive)
    {
        if (actionState == ItemTouchHelper.ACTION_STATE_SWIPE)
        {
            View itemView = viewHolder.itemView;

            TextView vNoSwipable = ((MessageListAdapter.ViewHolder) viewHolder).getNoSwipableView();
            if (dX > 0)
                vNoSwipable.setGravity(Gravity.CENTER_VERTICAL | Gravity.LEFT);
            else
                vNoSwipable.setGravity(Gravity.CENTER_VERTICAL | Gravity.RIGHT);

            vNoSwipable.setHeight(viewHolder.itemView.getHeight());
            c.save();
            c.translate(0, itemView.getTop()); //position text on the canvas
            vNoSwipable.draw(c);
            c.restore();

            super.onChildDraw(c, recyclerView, viewHolder, dX, dY, actionState, isCurrentlyActive);
        }

    }

    @Override
    public void onChildDrawOver(Canvas c, RecyclerView recyclerView, RecyclerView.ViewHolder viewHolder, float dX, float dY, int actionState, boolean isCurrentlyActive)
    {
        if (actionState == ItemTouchHelper.ACTION_STATE_SWIPE)
            super.onChildDrawOver(c, recyclerView, viewHolder, dX, dY, actionState, isCurrentlyActive);
    }
}