package com.ejgv.gvi.restapipns.serviceappregister;

import android.content.Context;
import android.os.AsyncTask;

import com.ejgv.gvi.restapipns.dto.DTOResponseGetSmsToken;
import com.ejgv.gvi.restapipns.dto.DTOResponseSimple;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class MezuPnsPRSService
{
    private Context mContext;

    /**
     * Constructor
     * @param context
     */
    public MezuPnsPRSService(Context context)
    {
        this.mContext = context;
    }

    /**
     * The class that uses createGetSmsTokenCall method must implements this interface
     * to interact with GetSmsTokenAsyncTask
     */
    public interface OnGetSmsTokenListener
    {
        void onPostGetSmsTokenAsyncTask(DTOResponseGetSmsToken response);
    }
    /**
     * Create GetSmsTokenAsyncTask instance
     * @param listener
     * @return AsyncTask
     */
    public AsyncTask createGetSmsTokenCall(OnGetSmsTokenListener listener,
                                           String gsm, String app_ref)
    {
        return new GetSmsTokenAsyncTask(mContext, listener,
                                        gsm, app_ref);
    }

    /**
     * The class that uses createRegisterCall method must implements this interface
     * to interact with RegisterAsyncTask
     */
    public interface OnRegisterListener
    {
        void onPostRegisterAsyncTask(DTOResponseSimple response);
    }
    /**
     * Create RegisterAsyncTask instance
     * @param listener
     * @return AsyncTask
     */
    public AsyncTask createRegisterCall(OnRegisterListener listener,
                                        String token_sms, String token_pns, String uuid_device, String uuid_app, String chn_provider,
                                        String app_version, String dev_vendor, String dev_model, String os_vendor, String os_version)
    {
        return new RegisterAsyncTask(mContext, listener,
                                        token_sms, token_pns, uuid_device, uuid_app, chn_provider,
                                        app_version, dev_vendor, dev_model, os_vendor, os_version);
    }


    /**
     * The class that creates createUnregisterCall method must implements this interface
     * to interact with UnregisterAsyncTask
     */
    public interface OnUnregisterListener
    {
        void onPostUnregisterAsyncTask(DTOResponseSimple response);
    }
    /**
     * Create UnregisterAsyncTask instance
     * @param listener
     * @return AsyncTask
     */
    public AsyncTask createUnregisterCall(OnUnregisterListener listener,
                                            String uuid_app, String uuid_device)
    {
        return new UnregisterAsyncTask(mContext, listener,
                                        uuid_app, uuid_device);
    }

}