package com.ejgv.gvi.restapipns.servicedataaccess;

import android.content.Context;
import android.os.AsyncTask;

import com.ejgv.gvi.restapipns.dto.DTOResponseGetPendingPns;
import com.ejgv.gvi.restapipns.dto.DTOResponseSimple;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class MezuPnsPCSService
{
    private Context mContext;

    /**
     * Constructor
     * @param context
     */
    public MezuPnsPCSService(Context context)
    {
        this.mContext = context;
    }

    /**
     * The class that uses createDeleteCall method must implements this interface
     * to interact with DeleteAsyncTask
     */
    public interface OnDeleteListener
    {
        void onPostDeleteAsyncTask(DTOResponseSimple response, String[] trans_ids);
    }
    /**
     * Create DeleteAsyncTask instance
     *
     * @param listener
     * @param uuid_app
     * @param uuid_device
     * @param trans_ids
     * @return
     */
    public AsyncTask createDeleteCall(OnDeleteListener listener,
                                      String uuid_app, String uuid_device, String[] trans_ids)
    {
        return new DeleteAsyncTask(mContext, listener,
                                    uuid_app, uuid_device, trans_ids);
    }

    /**
     * The class that uses createGetPendingPnsCall method must implements this interface
     * to interact with GetPendingPnsAsyncTask
     */
    public interface OnGetPendingPnsListener
    {
        void onPostGetPendingPnsAsyncTask(DTOResponseGetPendingPns response);
    }
    /**
     * Create GetPendingPnsAsyncTask instance
     *
     * @param listener
     * @param uuid_device
     * @param uuid_app
     * @param trans_id
     * @param ts_from
     * @return AsyncTask
     */
    public AsyncTask createGetPendingPnsCall(OnGetPendingPnsListener listener,
                                             String uuid_app, String uuid_device, String trans_id, long ts_from)
    {
        return new GetPendingPnsAsyncTask(mContext, listener,
                                        uuid_app, uuid_device, trans_id, ts_from);
    }

    /**
     * The class that uses createMarkAsReadCall method must implements this interface
     * to interact with GetPendingPnsAsyncTask
     */
    public interface OnMarkAsReadListener
    {
        void onPostMarkAsReadAsyncTask(DTOResponseSimple response);
    }
    /**
     * Create MarkAsReadAsyncTask instance
     * @param listener
     * @return AsyncTask
     */
    public AsyncTask createMarkAsReadCall(OnMarkAsReadListener listener,
                                          String uuid_app, String uuid_device, String trans_id)
    {
        return new MarkAsReadAsyncTask(mContext, listener,
                                        uuid_app, uuid_device, trans_id);
    }

    /**
     * The class that uses createUpdateTokenPnsCall method must implements this interface
     * to interact with UpdateTokenPnsAsyncTask
     */
    public interface OnUpdateTokenPnsListener
    {
        void onPostUpdateTokenPnsAsyncTask(DTOResponseSimple response);
    }
    /**
     * Create UpdateTokenPnsAsyncTask instance
     * @param listener
     * @return AsyncTask
     */
    public AsyncTask createUpdateTokenPnsCall(OnUpdateTokenPnsListener listener,
                                              String token_pns, String uuid_app, String uuid_device, String chn_provider,
                                              String app_version, String dev_vendor, String dev_model, String os_vendor, String os_version)
    {
        return new UpdateTokenPnsAsyncTask(mContext, listener,
                                            token_pns, uuid_app, uuid_device, chn_provider,
                                            app_version, dev_vendor, dev_model, os_vendor, os_version);
    }

}