package com.ejgv.gvi.restapitrace.service;

import android.content.ContentValues;

import com.ejgv.gvi.restapitrace.TraceHttpClient;
import com.ejgv.gvi.utils.UtilsApp;
import com.ejgv.gvi.utils.UtilsLog;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import org.json.JSONObject;

import java.net.URL;

import javax.net.ssl.HttpsURLConnection;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class AddTraceHttpClient extends TraceHttpClient
{
    private static final String TAG = "AddTraceHttpClient";

    // Service operation
    private static final String operation = "/json/add" ;

    // Service params
    private static final String PARAM_NAME = "w43tajsontrace";

    /**
     * Empty Constructor
     */
    public AddTraceHttpClient()
    {
        super();
    }

    /**
     * register
     * @param params
     * @return JSONObject
     */
    public JSONObject send( AddTraceParams params)
    {
        HttpsURLConnection conn = null;
        JSONObject json_response = new JSONObject();
        try
        {
            // Create URL
            URL url = new URL(MezuTraceConfig.getWsUrl()+ operation);

            // Create connection
            conn = (HttpsURLConnection) url.openConnection();

            // Add certificate for SSL connection
            setCertificate(conn);

            // Set Connection params
            conn.setReadTimeout(HTTP_CLI_READ_TIMEOUT);
            conn.setConnectTimeout(HTTP_CLI_CONNECT_TIMEOUT);

            // Set Connection properties
            conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
            conn.setRequestMethod("POST");
            conn.setDoOutput(true);
            conn.setUseCaches(false);

            // write POST params
            Gson gson = new Gson();
            ContentValues values=new ContentValues();
            values.put(PARAM_NAME, gson.toJson(params).toString());
            setPostParams(conn, values);

            UtilsLog.d(TAG, url.toString());
            Gson gson_p = new GsonBuilder().setPrettyPrinting().create();
            UtilsLog.d(TAG, gson_p.toJson(params));

            conn.connect();

            // Handle issues
            int statusCode = conn.getResponseCode();
            if ( statusCode != HttpsURLConnection.HTTP_OK )
                UtilsLog.d(TAG, UtilsApp.createResponseErrorMessage("send", statusCode, conn.getResponseMessage()));
        }
        catch (Exception e)
        {
            UtilsLog.d(TAG, "Exception in send", e);
        }
        finally
        {
            if(conn != null)
            {
                conn.disconnect();
            }
            return json_response;
        }
    }
}