package com.ejgv.gvi.rss;

import android.os.Parcel;
import android.os.Parcelable;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import java.util.Locale;

public class RSSFeedItem implements Parcelable
{
	private String title;
	private String link;
	private String description;
	private String author;
	private String pubDate;

	public RSSFeedItem(String title, String link, String description, String author, String pubDate)
	{
		this.title = title;
		this.link = link;
		this.description = description;
		this.author = author;
		this.pubDate = pubDate;
	}

    /**
	 * @return the title
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * @return the link
	 */
	public String getLink() {
		return link;
	}

	/**
	 * @return the description
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @return the author
	 */
	public String getAuthor() {
		return author;
	}

	/**
	 * @return the pubDate
	 */
	public GregorianCalendar getPubDate() {
		GregorianCalendar calendar = null;
		if (pubDate != null && !pubDate.equals("")) {
			SimpleDateFormat formatter = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss zzz", Locale.ENGLISH);
			calendar = new GregorianCalendar();
			try {
				calendar.setTime(formatter.parse(pubDate));
			} catch (ParseException e) {
				calendar = null;
			}
		}
		return calendar;
	}

	private RSSFeedItem(Parcel in) {
		this.title = in.readString();
		this.link = in.readString();
		this.description = in.readString();
		this.author = in.readString();
		this.pubDate = in.readString();
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(title);
        dest.writeString(link);
        dest.writeString(description);
        dest.writeString(author);
        dest.writeString(pubDate);
    }

    public static final Creator<RSSFeedItem> CREATOR = new Creator<RSSFeedItem>() {
        @Override
        public RSSFeedItem createFromParcel(Parcel in) {
            return new RSSFeedItem(in);
        }

        @Override
        public RSSFeedItem[] newArray(int size) {
            return new RSSFeedItem[size];
        }
    };
}