package com.ejgv.gvi.rss;

/**
 * Created by ivanbatura on 21/4/16.
 */
import java.text.SimpleDateFormat;
import java.util.List;

import android.content.Context;
import android.text.Html;
import android.text.format.DateUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.ejgv.gvi.Constants;
import com.ejgv.gvi.R;
import com.ejgv.gvi.utils.Utils;
import com.ejgv.gvi.utils.UtilsApp;

public class RSSFeedItemAdapter extends ArrayAdapter<RSSFeedItem>
{
    Context mContext;
    private int mLayoutResourceId;

    public RSSFeedItemAdapter(Context context, int layoutResourceId, List<RSSFeedItem> items)
    {
        super(context, layoutResourceId, items);

        this.mContext = context;
        this.mLayoutResourceId = layoutResourceId;
    }

    private final class ViewHolder
    {
        TextView txt_title;
        TextView txt_date;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent)
    {
        final ViewHolder holder;

        if (convertView == null) {
            // inflate the layout
            convertView = LayoutInflater.from(mContext).inflate(mLayoutResourceId, null);
            holder = new ViewHolder();
            holder.txt_title = (TextView) convertView.findViewById(R.id.li_gvi_rssfeeditem_title_txt);
            holder.txt_date = (TextView) convertView.findViewById(R.id.li_gvi_rssfeeditem_date_txt);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }

        // object item based on the position
        final RSSFeedItem item = (RSSFeedItem) getItem(position);

        if (item != null) {
            holder.txt_title.setText(Html.fromHtml((UtilsApp.limit(item.getTitle(), Constants.FEED_TEXT_MAX_LENGTH))));
            CharSequence chsDate = DateUtils.getRelativeTimeSpanString(mContext, item.getPubDate().getTime().getTime(), false);

            holder.txt_date.setText(chsDate);
        }

        return convertView;
    }
}