package com.ejgv.gvi.ui;

import android.content.Context;
import android.support.v7.widget.AppCompatEditText;
import android.text.TextUtils;
import android.util.AttributeSet;

import com.ejgv.gvi.R;
import com.ejgv.gvi.utils.Utils;

/**
 * Created by Batura Mobile Solutions (Koldo Calvo).
 */
public class TypefaceEditText extends AppCompatEditText
{
    private String fontFile = "fonts/%1$s.ttf";

    public TypefaceEditText(Context context)
    {
        super(context);
    }

    public TypefaceEditText(Context context, AttributeSet attrs)
    {
        super(context, attrs);
        setTypeFaceFromAttr(getAttrCustomTypeFace(attrs));
    }

    public TypefaceEditText(Context context, AttributeSet attrs, int defStyleAttr)
    {
        super(context, attrs, defStyleAttr);
        setTypeFaceFromAttr(getAttrCustomTypeFace(attrs));
    }

    public void setFontFile(String fontName)
    {
        this.fontFile = String.format(fontFile, fontName);
    }

    private String getAttrCustomTypeFace(AttributeSet attrs)
    {
        return getContext().getTheme().obtainStyledAttributes(attrs,
                R.styleable.TypefaceTextView, 0, 0).getString(
                R.styleable.TypefaceTextView_typeface);
    }

    public void setTypeFaceFromAttr(String typefaceName)
    {
        if (!isInEditMode() && !TextUtils.isEmpty(typefaceName))
        {
            setFontFile(typefaceName);
            setTypeface(Utils.getTypeface(getContext(), fontFile));
        }
    }
}
