package com.ejgv.gvi.utils;

import android.content.Context;
import android.util.Log;

import com.ejgv.gvi.dmo.DMOContact;
import com.ejgv.gvi.restapipns.dto.DTOText;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * Created by ivanbatura on 27/4/16.
 */
public class ContactsLoader {

    Context mContext;

    public ContactsLoader(Context mContext) {
        this.mContext = mContext;
    }

    public String loadJSONFromAsset()
    {
        String json = null;
        try {
            InputStream is = mContext.getAssets().open("json/contacts.json");
            int size = is.available();
            byte[] buffer = new byte[size];
            is.read(buffer);
            is.close();
            json = new String(buffer, "UTF-8");
        } catch (IOException ex) {
            ex.printStackTrace();
            return null;
        }
        return json;
    }

    public ArrayList<DMOContact> getContacts()
    {

        ArrayList<DMOContact> contacts = new ArrayList<>();

        try {
            JSONArray contactsRawArray = new JSONArray(loadJSONFromAsset());

            for (int i = 0; i < contactsRawArray.length(); i++) {
                JSONObject contactObject = contactsRawArray.getJSONObject(i);
                JSONObject euTranslation = contactObject.getJSONObject("eu");
                JSONObject esTranslation = contactObject.getJSONObject("es");

                DMOContact contact = new DMOContact();
                contact.setLat(contactObject.getDouble("lat"));
                contact.setLng(contactObject.getDouble("lng"));

                contact.setName(new DTOText(euTranslation.getString("name"),esTranslation.getString("name")));
                contact.setAddressLine1(new DTOText(euTranslation.getString("addressLine1"),esTranslation.getString("addressLine1")));
                contact.setAddressLine2(new DTOText(euTranslation.getString("addressLine2"),esTranslation.getString("addressLine2")));

                contacts.add(contact);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

       return contacts;
    }
}
